<?php
/**
 * Token interceptor system plugin
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Sponsorship Reward
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 *
 */

// no direct access
defined('_JEXEC') or die;


class plgSystemTokeninterceptor extends JPlugin
{

    protected $autoloadLanguage = true;

    public function __construct(&$subject, $config = array())
    {
        parent::__construct($subject, $config);

    }

    public function onAfterInitialise(){
        $app = JFactory::getApplication();

        if (($app->isSite() && $this->params->get('use_frontend')) || ($app->isAdmin() && $this->params->get('use_backend'))) {
            register_shutdown_function(array($this,'killdie'));

            if(isset($_SESSION['throwTokenInterceptorError'])){
                unset($_SESSION['throwTokenInterceptorError']);
                $message = $this->params->get('message',JText::_('PLG_SYSTEM_TOKENINTERCEPTOR_MESSAGE'));
                $app->enqueueMessage($message, 'warning');
            }
        }

    }

    public function killdie(){
        //Check if the script will throw a token error message
        $content = ob_get_contents();
        if($content==JText::_('JINVALID_TOKEN')){
            //Force using php session because database session is not available
            //As Joomla close the session via its register_shutdown_function we need to create one if needed
            if(session_status()===PHP_SESSION_NONE){
                session_start();
            }
            $_SESSION['throwTokenInterceptorError'] = true;
            session_write_close();

            //if possible exit the Joomla's way
            if(class_exists('JControllerLegacy')){
                $controller = new JControllerLegacy();
                $controller->setRedirect(JURI::current());
                $controller->redirect();
            }else{
                header('Location: ' . JURI::current());
            }
        }
    }
}
